import { j as n } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ve, useState as G, useMemo as w, useRef as W, useEffect as Be, useCallback as ze } from "react";
import { isMobile as B } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as Te, Table as A, Skeleton as ke } from "antd";
import Me from "../../BitzDrawer/index.mjs";
import Le from "../../BitzLoadMore/index.mjs";
import Ee from "../../BitzPagination/index.mjs";
import We from "../../BitzNoData/index.mjs";
import Ae, { TableContext as He } from "../Store/index.mjs";
import Pe from "../TableSkeleton/index.mjs";
import { columnSort as F, genColumnKey as J } from "../Store/utils/index.mjs";
import H from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import Oe from "../../../node_modules/lodash-es/at.mjs";
function Ve({
  showPagination: N = !0,
  fillEvenRow: P = !0,
  evenRowBgColor: O = "#f9f9f9",
  height: m,
  dataSource: t = [],
  total: z = 0,
  columns: b,
  loading: j = !1,
  skeletonNum: Q = 2,
  skeletonRender: V,
  skeletonRowNum: Y = 4,
  skeletonRowsWidth: Z = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: S = () => {
  },
  mobileRefreshEmit: I = () => {
  },
  operationFilter: T,
  enableControlPage: ee,
  pagination: ne,
  paginationEmit: se = () => {
  },
  mobilePageHeight: le = 500,
  mobileCancelText: te = "取消",
  noDataTitle: re,
  noDataImg: oe,
  color: ie,
  size: $,
  showTableTool: ae = !0,
  tableAction: he,
  tableToolbar: de,
  selectionBar: ce,
  scroll: o,
  resetPage: fe,
  ...i
}) {
  const { token: xe } = Te.useToken(), d = ve(He), [be, k] = G(!1), ue = w(() => !!(t != null && t.length) && (t == null ? void 0 : t.length) >= z, [t, z]), [ge, ye] = G([]), we = (s, e) => {
    var a;
    const l = (a = T == null ? void 0 : T(s, e)) == null ? void 0 : a.filter(
      (h) => h.type !== "divider"
    );
    l != null && l.length && (ye(l), k(!0));
  }, _ = () => {
    k(!1);
  }, je = (s) => {
    var e;
    k(!1), (e = s.onClick) == null || e.call(s);
  }, u = W(null), g = H(u), M = W(null), L = H(M), D = W(null), y = H(D), pe = (s) => {
    var X, q;
    const e = s.length, l = s.filter((x) => x.width), h = l.map((x) => x.width).reduce((x, Ce) => x + Ce, 0);
    let c = 0;
    if (u.current) {
      const x = window.getComputedStyle(u.current);
      c = parseInt(x.getPropertyValue("--toolCell-width"));
    }
    let r = 0;
    i.rowSelection && (r += c), i.expandable && (r += c);
    const f = (q = (X = M.current) == null ? void 0 : X.querySelector(
      ".ant-table-body"
    )) == null ? void 0 : q.clientWidth, v = parseInt(`${C.x}`) || 0, me = Math.max(v, f), U = (parseInt(`${me}`) || 0) - h - r;
    return U >= 0 ? U / (e - l.length) : void 0;
  }, { y: E } = w(() => {
    if (typeof m > "u")
      return {};
    let s = 40, e = 40, l = 10;
    if (u.current) {
      const f = window.getComputedStyle(u.current);
      s = parseInt(f.getPropertyValue("--cell-block")), e = parseInt(f.getPropertyValue("--toolbar-height")), l = parseInt(f.getPropertyValue("--container-gap")) || 0;
    }
    const a = (y == null ? void 0 : y.height) || 0, h = a ? l : 0;
    return { y: m - a - h - e - s };
  }, [
    m,
    y == null ? void 0 : y.height,
    g == null ? void 0 : g.height,
    L == null ? void 0 : L.height
  ]), C = w(() => o != null && o.x ? { x: o.x, y: o.y || E } : o != null && o.y ? { x: 1e3, y: o.y } : { x: 1e3, y: E }, [o, E]), p = w(() => {
    const s = (c) => c.map((r) => {
      const f = J(
        (r == null ? void 0 : r.key) || (r == null ? void 0 : r.dataIndex),
        r.index
      ), v = d.columnsMap[f];
      return v && v.show === !1 ? !1 : r.children ? {
        ...r,
        children: s(r.children)
      } : r;
    }).filter(Boolean), e = s(b);
    if (B)
      return e.sort(F(d.columnsMap));
    const l = e.sort(F(d.columnsMap)), a = pe(l), h = l.map((c) => ({
      ...c,
      ...c.width ? {} : {
        // 给未设置width的列设置平均数
        width: a
      }
    }));
    return [A.SELECTION_COLUMN, A.EXPAND_COLUMN, ...h];
  }, [
    d.columnsMap,
    b,
    B,
    C.x,
    i.rowSelection,
    i.expandable,
    g == null ? void 0 : g.height
  ]);
  Be(() => {
    if (b && b.length > 0) {
      const s = b.map(
        (e) => (
          // @ts-ignore
          J((e == null ? void 0 : e.key) ?? (e == null ? void 0 : e.dataIndex), e == null ? void 0 : e.dataIndex)
        )
      );
      d.setSortKeyColumns(s);
    }
  }, [b]);
  const Ne = w(() => `${$ ?? (d == null ? void 0 : d.tableSize) ?? "lg"}BitzTable`, [$, d.tableSize]), K = w(() => ({
    "--evenRow-BgColor": O
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    O
    /** token.Table?.borderColor */
  ]), R = ze(
    (s, e) => P ? e % 2 === 0 ? "oddRow" : "evenRow" : "",
    [P]
  );
  return /* @__PURE__ */ n.jsxs("div", { className: "bitzTableBlock", children: [
    !B && /* @__PURE__ */ n.jsxs(
      "div",
      {
        ref: u,
        className: `bitzTableContainer ${Ne}`,
        style: { height: m },
        children: [
          /* @__PURE__ */ n.jsxs("div", { className: "bitzTableContainerBody", ref: M, children: [
            ae && /* @__PURE__ */ n.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              he || /* @__PURE__ */ n.jsx("div", {}),
              de,
              (i == null ? void 0 : i.rowSelection) && /* @__PURE__ */ n.jsx(n.Fragment, { children: ce })
            ] }),
            /* @__PURE__ */ n.jsx(
              A,
              {
                columns: p,
                dataSource: t,
                loading: !1,
                pagination: !1,
                scroll: C,
                ...i,
                style: K,
                rowClassName: R
              }
            ),
            /* @__PURE__ */ n.jsx(
              Pe,
              {
                columns: p,
                dataLength: t.length,
                scroll: C,
                rowSelection: i.rowSelection,
                expandable: i.expandable,
                style: K,
                rowClassName: R,
                loading: j
              }
            )
          ] }),
          N && /* @__PURE__ */ n.jsx(
            Ee,
            {
              elRefInstance: D,
              enableControl: ee,
              pagination: ne,
              total: z,
              dataSource: t,
              resetPage: fe,
              paginationEmit: se
            }
          )
        ]
      }
    ),
    B && /* @__PURE__ */ n.jsxs(n.Fragment, { children: [
      (j || (t == null ? void 0 : t.length) > 0) && /* @__PURE__ */ n.jsx(
        Le,
        {
          color: ie,
          height: le,
          loading: j,
          showNoMore: ue,
          refreshEmit: I,
          loadEmit: S,
          extra: /* @__PURE__ */ n.jsxs("div", { className: "mobileTable", children: [
            t == null ? void 0 : t.map((s, e) => /* @__PURE__ */ n.jsx(
              "div",
              {
                className: "mobileTableRow",
                onClick: () => we(s, e),
                children: /* @__PURE__ */ n.jsx("div", { className: "rowBox", children: p == null ? void 0 : p.map(
                  (l, a) => {
                    var h;
                    return /* @__PURE__ */ n.jsx("div", { children: !(l != null && l.mobileHide) && /* @__PURE__ */ n.jsxs("div", { className: "row", children: [
                      !l.mobileHideLabel && /* @__PURE__ */ n.jsxs("div", { className: "label", children: [
                        `${l.title}`,
                        "："
                      ] }),
                      /* @__PURE__ */ n.jsx("div", { className: "value", children: ((h = l == null ? void 0 : l.render) == null ? void 0 : h.call(
                        l,
                        Oe(s, (l == null ? void 0 : l.dataIndex) || ""),
                        s,
                        e
                      )) || (s == null ? void 0 : s[l.dataIndex]) })
                    ] }) }, a);
                  }
                ) })
              },
              e
            )),
            j && Array.from({ length: Q }).map((s, e) => /* @__PURE__ */ n.jsx("div", { className: "mobileTableRow", children: /* @__PURE__ */ n.jsx("div", { className: "rowBox", children: V ? V() : /* @__PURE__ */ n.jsx(
              ke,
              {
                title: !1,
                paragraph: {
                  rows: Y,
                  width: Z
                },
                active: !0
              }
            ) }) }, e)),
            /* @__PURE__ */ n.jsx(
              Me,
              {
                className: "tableMobileDrawer",
                open: be,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: _,
                children: /* @__PURE__ */ n.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ n.jsx("div", { className: "boxBody", children: ge.map((s, e) => /* @__PURE__ */ n.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => je(s),
                      ...s.danger && {
                        style: { color: xe.colorError }
                      },
                      children: s.label
                    },
                    e
                  )) }),
                  /* @__PURE__ */ n.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ n.jsx("div", { className: "boxFooter", onClick: _, children: te })
                ] })
              }
            )
          ] })
        }
      ),
      !j && /* @__PURE__ */ n.jsx(We, { data: t, title: re, img: oe })
    ] })
  ] });
}
const Se = (N) => (
  // @ts-ignore
  /* @__PURE__ */ n.jsx(Ae, { initValue: N, children: /* @__PURE__ */ n.jsx(Ve, { ...N }) })
);
export {
  Se as default
};
